import java.util.*;

public class Bounds {

    
    static class AlternateSet<E>{
        HashSet<E> a = new HashSet<>();
        // Adds all elements in c to this set
        // (that are not already present)

        // Slide 37
//        void addAll(Set<E> c){
//            a.addAll(c);
//        }

        // Slide 38
//        void addAll(Collection<E> c){
//            a.addAll(c);
//        }

        // Slide 39
         <T extends E> void addAll(Collection<T> c){
            a.addAll(c);
         }


    }

    // Slide 41
    static class UtilsGenerified {
        static <T extends Number> double sumList(List<T> lst) {
            double result = 0.0;
            for (Number n : lst) { // T also works
                result += n.doubleValue();
            }
            return result;
        }

//         Slide 42
//        static <T> void copyTo(List<T> dst, List<T> src) {
//            for (T t : src)
//                dst.add(t);
//        }


    static <T1, T2 extends T1> void copyTo(List<T1> dst, List<T2> src) {
        for (T2 t : src)
            dst.add(t);
    }


    }


    public static void main(String[] args){
        // Slide 39
        ArrayList<Double> doublesList = new ArrayList<>(Arrays.asList(1.0,2.0));
        ArrayList<Integer> intList = new ArrayList<>(Arrays.asList(1, 2));
        HashSet<Double> doubleSet = new HashSet<>(doublesList);

        AlternateSet<Double> newDoubles = new AlternateSet<>();
        newDoubles.addAll(doublesList);
        newDoubles.addAll(doubleSet);
//        newDoubles.addAll(intList);

        AlternateSet<Number> newNumbers = new AlternateSet<>();
        newNumbers.addAll(doublesList);
        newNumbers.addAll(doubleSet);
        newNumbers.addAll(intList);



    }
}
