import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashSet;

public class GenericArrays {

    static class LibraryHolding{
        private Date DueDate;
        private int id;
        private HashSet<Integer> currentIds = new HashSet<>();
        LibraryHolding(int id){
            assert !currentIds.contains(id) : "The id is already taken";
            this.id = id;
            DueDate = new Date();
            DueDate.setTime(0);
        }

        public void setDueDate(Date dueDate) {
            DueDate = dueDate;
        }
    }

    static class Book extends LibraryHolding{
        String bookName;
        ArrayList<String> chapters;
        Book(int id, String bookName, ArrayList<String> chapters) {
            super(id);
            this.bookName = bookName;
            this.chapters = chapters;
            
        }

        public String getBookName() {
            return bookName;
        }

        public ArrayList<String> getChapters() {
            return chapters;
        }
        public String toString(){
            return bookName;
        }
    }
    
    static class CD extends LibraryHolding{
        String cdName;
        CD(int id, String cdName) {
            super(id);
            this.cdName = cdName;
        }

        public String getCdName() {
            return cdName;
        }
    }
    
    static void replace3(LibraryHolding[] arr, LibraryHolding h) {
        arr[3] = h;
    }

    static void maybeSwap(LibraryHolding[] arr){
        if(arr[2].DueDate.before(arr[3].DueDate)) {

            var temp = arr[2];
            arr[2] = arr[3];
            arr[3] = temp;
        }
    }
    
    
    public static void main(String[] args){
        Book book1 = new Book(1,"Ardi's Fantastic CSE331 class", new ArrayList<String>());
        Book book2 = new Book(2,"The Hobbit ", new ArrayList<String>());
        Book book3 = new Book(3,"The Adventures of Tom Bombadil  ", new ArrayList<String>());
        Book book4 = new Book(4,"The Road Goes Ever On ", new ArrayList<String>());

        book3.setDueDate(new Date(-1000));
        book4.setDueDate(new Date(1000));
        Book[] books = {book1, book2, book3, book4};
        System.out.println("books before: "+ Arrays.toString(books));
        maybeSwap(books);
        System.out.println("books after: "+Arrays.toString(books));

        LibraryHolding mysteryCD = new CD(6, "CSE331");

        replace3(books, mysteryCD);

        Book b = books[3];
        b.getChapters();



    }


}
