import java.util.*;

public class Wildcards {

    // Slide 44
    static class AlternateSet<E>{
        HashSet<E> a = new HashSet<>();

        // Previously
//        <T extends E> void addAll(Collection<T> c){
//            a.addAll(c);
//        }

        // Now
        void addAll(Collection<? extends E> c){
            a.addAll(c);
        }


    }

    // Slide 48
    static <T> void copyTo(List<? super T> dst, List<? extends T> src) {
        for (T t : src) {
            dst.add(t);
        }
    }

    // Slide 51
//    void printAll(List<Number> lst) {
//        System.out.println("Printing: " + lst);
//    }
//
//    static void printAll(List<?> lst) {
//        System.out.println("Printing: " + lst);
//    }
//
//    static void printAll(List<? extends Number> lst) {
//        System.out.println("Printing: " + lst);
//    }

    // Slide 52
    class NewInteger  extends Number{
        private Number pi;

        public NewInteger(Number i) {
            this.pi = i;
        }

        @Override
        public int intValue() {
            return 0;
        }

        @Override
        public long longValue() {
            return 0;
        }

        @Override
        public float floatValue() {
            return 0;
        }

        @Override
        public double doubleValue() {
            return 0;
        }
    }

    class PositiveInteger extends NewInteger{


        public PositiveInteger(Integer i) {
            super(i);
            assert i.intValue() > 0;
        }

    }

    class NegativeInteger extends NewInteger{

        public NegativeInteger(Integer i) {
            super(i);
            assert i.intValue() < 0;
        }

    }




    public static void main(String[] args){

        // Slide 47
        ArrayList<Integer> intList2 = new ArrayList<Integer>(Arrays.asList(1,2,3));
        ArrayList<Number> numList = new ArrayList<>();

        System.out.println("numList: " + numList + " intList " + intList2);
        copyTo(numList, intList2);
        System.out.println("numList: " + numList + " intList " + intList2);


        // Slide 53
//        ArrayList<Number> intList = new ArrayList<>();
//
//        System.out.println("numList: " + numList + " intList " + intList);
//        copyTo(intList, numList);
//        System.out.println("numList: " + numList + " intList " + intList);
//

        // Slide 56

//        printAll(intList);

        // Slide 57
        Object o;
        Number n;
        NewInteger i;
        PositiveInteger p;

        ArrayList<? extends NewInteger> lei;


        lei = new ArrayList<Object>();
        lei = new ArrayList<Number>();
        lei = new ArrayList<NewInteger>();
        lei = new ArrayList<PositiveInteger>();
        lei = new ArrayList<NegativeInteger>();

        o = lei.get(0);
        n = lei.get(0);
        i = lei.get(0);
        p = lei.get(0);
        lei.add(o);
        lei.add(n);
        lei.add(i);
        lei.add(p);
        lei.add(null);


        // Slide 63
//        List<? super NewInteger> lsi;
//
//
//        lsi = new ArrayList<Object>();
//        lsi = new ArrayList<Number>();
//        lsi = new ArrayList<NewInteger>();
//        lsi = new ArrayList<PositiveInteger>();
//        lsi = new ArrayList<NegativeInteger>();
//
//        lsi.add(o);
//        lsi.add(n);
//        lsi.add(i);
//        lsi.add(p);
//        lsi.add(null);
//        o = lsi.get(0);
//        n = lsi.get(0);
//        i = lsi.get(0);
//        p = lsi.get(0);

    }

}
